package com.ahai.vgk_game_services

import android.app.Activity
import android.os.Build
import com.google.android.play.core.review.ReviewManagerFactory
import io.flutter.plugin.common.MethodChannel.Result

class InAppReviewHandler(private val activityContext: Activity, private val result: Result) {
    fun startInAppReviewDialog() {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {

            val manager = ReviewManagerFactory.create(activityContext)
            val request = manager.requestReviewFlow()

            request.addOnCompleteListener {
                if (it.isSuccessful) {
                    val flow = manager.launchReviewFlow(activityContext, it.result)
                    flow.addOnCompleteListener {
                        result.success(true)
                    }
                } else {
                    result.error("UNAVAILABLE", "The review flow is unavailable, it might exceed the trigger quota", null)
                }
            }
        } else {
            result.error("UNAVAILABLE", "In app review only support api 21 above", null)
        }
    }
}