package com.ahai.vgk_game_services

import android.app.Activity
import com.google.android.gms.games.LeaderboardsClient
import io.flutter.plugin.common.MethodChannel.Result

class LeaderboardsController(private val client: LeaderboardsClient, private var activity: Activity?) {

    companion object {
        const val RC_LEADERBOARD_UI = 9004
    }

    fun submitScore(id: String, score: Int, result: Result) {
        client.submitScore(id, score.toLong())
        result.success("success")
    }

    fun showLeaderboard(id: String, result: Result) {
        client.getLeaderboardIntent(id).addOnSuccessListener { intent -> 
            activity?.startActivityForResult(intent, RC_LEADERBOARD_UI)
        }
        result.success("success")
    }

    fun showAllLeaderboards(result: Result) {
        client.allLeaderboardsIntent.addOnSuccessListener { intent -> 
            activity?.startActivityForResult(intent, RC_LEADERBOARD_UI) 
        }
        result.success("success")
    }
}